// Converter from ASM files to Exec strings, release 1.0   (C) Zeljko Juric
// You need to have TIGCC library 2.0 or higher to compile it

#include <nostub.h>
#include <alloc.h>
#include <mem.h>
#include <args.h>
#include <estack.h>
#include <statline.h>
#include <vat.h>

int _ti89,_ti92plus;

unsigned char Tab1[]={ENDSTACK_TAG,ENDPRGM_ITAG,EXT_INSTR_TAG,0,NEWLINE_TAG,
  END_TAG,0};
unsigned char Tab2[]={0,STR_TAG,EXEC_ITAG,EXT_INSTR_TAG,0,NEWLINE_TAG,
  PRGM_ITAG,EXT_INSTR_TAG,END_TAG,0,0,0,FUNC_TAG};

char *ErrMessages[]={"Conversion finished.","Wrong number of arguments!",
  "Wrong type of the first argument!","Wrong type of the second argument!",
  "Source file does not exist!","Source file is not an ASM file!",
  "Source file is too big!","Cannot create destination file!",
  "Not enough memory!"};

#define check(err_no,condition) \
  {if(condition) {ST_showHelp(ErrMessages[err_no]); return;}}

void _main(void)
{
  ESI ArgPtr=top_estack;
  char *SrcName,*DestName;
  char *HexDigits="0123456789ABCDEF";
  SYM_ENTRY *SrcFile,*DestFile;
  unsigned char Byte,*SrcBase,*DestBase;
  unsigned int i,SrcLen;
  check(1,ArgCount()!=2);
  check(2,GetArgType(ArgPtr)!=STR_TAG);
  SrcName=GetSymstrArg(ArgPtr);
  check(3,GetArgType(ArgPtr)!=STR_TAG);
  DestName=GetSymstrArg(ArgPtr);
  check(4,!(SrcFile=SymFindPtr(SrcName,0)));
  check(5,*(unsigned char*)HToESI(SrcFile->handle)!=ASM_TAG);
  check(6,(SrcLen=*(unsigned*)(SrcBase=HeapDeref(SrcFile->handle))-1)>32000);
  check(7,!(DestFile=DerefSym(SymAdd(DestName))));
  if(!(DestFile->handle=HeapAlloc(2*SrcLen+25)))
    {
      SymDel(DestName);
      check(8,TRUE);
    }
  DestBase=HeapDeref(DestFile->handle);
  *(unsigned*)DestBase=2*SrcLen+20;
  memcpy(DestBase+2,Tab1,7);
  SrcBase+=2; DestBase+=9;
  for(i=0;i<SrcLen;i++)
    {
      Byte=*SrcBase++;
      *DestBase++=HexDigits[Byte>>4];
      *DestBase++=HexDigits[Byte&0x0F];
    }
  memcpy(DestBase,Tab2,13);
  check(0,TRUE);
}

